-- Procedures to populate the 'delta' value

DELIMITER //

CREATE TRIGGER PopulateDelta BEFORE INSERT ON value_stat 
FOR EACH ROW BEGIN 
   DECLARE prev_value BIGINT(20);

   IF NEW.value_stat_string IS NULL THEN
      SELECT vst.value_stat_number INTO prev_value FROM value_stat vst
         WHERE vst.value_stat_name = NEW.value_stat_name 
         ORDER BY vst.value_stat_id DESC LIMIT 1; 
      SET NEW.value_stat_delta = NEW.value_stat_number - prev_value; 
   END IF;
END
//

DELIMITER ;
